stapel segment stack 'stack'
	db 100h dup(?)
stapel ends

data_seg segment 'data'
	fehler db "Falsche Eingabe", '$'
	ende_meldung1 db "Fibonnacci von ", '$'
	ende_meldung2 db " ist: ", '$'
data_seg ends

code    segment
	assume cs:code, ds:data_seg

;; \brief Gibt n als Dezimalzahl aus
;; \param 1 (stack) - n
b2a PROC
	push	bp
	mov	bp,sp			; Zur Adressierung des Stack wird BP verwendet.

	push	ax			; sichern von ax, da benutzt
	push	cx			; sichern von cx, da benutzt
	push	dx			; sichern von dx, da benutzt
		
	mov	ax,[bp+04h]             ; ax auslesen

	mov cx , 0        		; Anfangswert fuer Reste
	mov si , 10
konvert:
	mov dx , 0
	div si        			; Division durch 10
	push dx         		; Rest auf Stack
	inc cx        			; Reste zaehlen
	cmp ax, 0      			; Ergebnis = 0?
	jnz konvert   			; Umwandlung abbrechen
ausgabe:
	pop dx          		; Rest vom Stack holen
	add dl , 30h   			; in ASCII wandeln
	mov ah, 2
	int 21h
	loop ausgabe 			; weiter , wenn noch Reste da

	pop	dx
	pop	cx
	pop	ax

	mov	sp,bp                   ; Wiederherstellen des Stackpointers - hier relativ egal
	pop	bp                      ; entfernen des gesicherten Registers bp

	RET	2                       ; raus aus der Funktion und entfernen von Argumenten aus Stack

b2a ENDP

;; \brief Berechnen der Fibonacci von n
;; \param 1 (stack) - n
;; \return ax berechnete Fibonacci-Zahl
fib PROC                   		;Uebergabe des Wertes auf dem Stack,Rueckgabe in AL
	push	bp
	mov	bp,sp			;Zur Adressierung des Stack wird BP verwendet.

	push	cx			; sichern von cx, da benutzt
	push	dx			; sichern von dx, da benutzt
		
	mov	cx,[bp+04h]             ; cx auslesen
	
	cmp	cx, 0			; wenn cx 0
	je	fib_0

	cmp cx, 1
	je fib_1
	
	jmp calc_fib
fib_0:
	mov ax, 0
	jmp ende_fib
	
fib_1:
	mov ax, 1
	jmp ende_fib

calc_fib:
	dec cx
	push cx
	call fib
	mov dx, ax
	
	dec cx
	push cx
	call fib
	add ax, dx
	
ende_fib:
	pop dx
	pop	cx
	mov	sp,bp                   ; Wiederherstellen des Stackpointers - hier relativ egal
	pop	bp                      ; entfernen des gesicherten Registers bp

	RET	2                       ; raus aus der Funktion und entfernen von Argumenten aus Stack

fib ENDP


start:  
	mov ax, data_seg
	mov ds, ax

marke:
	mov ah, 08h      ; Laden der Int. - Funktionsnummer
                         ; Zeichen lesen aber nicht ausgeben
	int 21h          ; Ausloesen des Int
	cmp al, 1bh      ; ESC - Taste?
	je  ende

	cmp al, 30h      ; Zeichen kleiner 30h?
	jb error_ende

	cmp al, 39h      ; Zeichen groesser 39 h?
	ja error_ende
ende:	
	mov bx, ax	; ax über bx sichern
	mov bh, 0
	sub bx, 30h	; berechnen der Zahlendarstellung der Eingabe

	mov ah, 09h
	mov dx, offset ende_meldung1
	int 21h		; Ausgabe der Melung Teil 1

	push bx
	call b2a	; Ausgabe der Eingegebenen Zahl

	mov ah, 09h
	mov dx, offset ende_meldung2
	int 21h		; Ausgabe der Meldung Teil 2
	
	push bx
	call fib	; Berechnung der Fib-Zahl

	push ax
	call b2a	; Ausgabe der Fib-Zahl

	mov ax, 4c00h    ; Rueckkehr zu DOS
	int 21h

error_ende:
	mov ah, 09h
	mov dx, offset fehler
	int 21h
	mov ax, 4c01h    ; Rueckkehr zu DOS
	int 21h
code ends
end start                ; Adresse des Programmbeginns